diff --git a/gcc/m2/mc/decl.mod b/gcc/m2/mc/decl.mod
index c3ee646caaf..37fc3962695 100644
--- a/gcc/m2/mc/decl.mod
+++ b/gcc/m2/mc/decl.mod
@@ -7301,15 +7413,593 @@ END getParameterVariable ;
 
 PROCEDURE doParamTypeEmit (p: pretty; paramnode, paramtype: node) ;
 BEGIN
-   assert (isParam (paramnode) OR isVarParam (paramnode)) ;
-   IF isForC (paramnode) AND isProcType (skipType (paramtype))
-   THEN
-      doFQNameC (p, paramtype) ;
-      outText (p, "_C")
+   assert (isParam (paramnode) OR isVarParam (paramnode)) ;
+   IF isForC (paramnode) AND isProcType (skipType (paramtype))
+   THEN
+      doFQNameC (p, paramtype) ;
+      outText (p, "_C")
+   ELSE
+      doTypeNameC (p, paramtype) ;
+      doOpaqueModifier (p, paramnode) ;
+      (*
+      IF nodeUsesOpaque (paramnode) AND (NOT getNodeOpaqueVoidStar (paramnode))
+      THEN
+         outText (p, '__opaque')
+      END
+      *)
+   END
+END doParamTypeEmit ;
+
+
+(*
+   doParamTypeNameModifier - Add an _ to an unbounded parameter which is non var.
+*)
+
+PROCEDURE doParamTypeNameModifier (p: pretty; ptype: node; varparam: BOOLEAN) ;
+BEGIN
+   IF (NOT varparam) AND isArray (ptype) AND isUnbounded (ptype)
+   THEN
+      outText (p, '_')
+   END
+END doParamTypeNameModifier ;
+
+
+(*
+   initOpaqueCastState - assign fields opaque and voidstar in opaquestate.
+*)
+
+PROCEDURE initOpaqueCastState (VAR opaquestate: opaqueCastState; opaque, voidstar: BOOLEAN) ;
+BEGIN
+   opaquestate.opaque := opaque ;
+   opaquestate.voidStar := voidstar
+END initOpaqueCastState ;
+
+
+(*
+   initNodeOpaqueCastState - assign opaque and currentvoidstar
+*)
+
+PROCEDURE initNodeOpaqueCastState (n: node; opaque, voidstar: BOOLEAN) ;
+BEGIN
+   CASE n^.kind OF
+
+   opaquecast  :  initOpaqueCastState (n^.opaquecastF.opaqueState, opaque, voidstar) |
+   funccall    :  initOpaqueCastState (n^.funccallF.opaqueState, opaque, voidstar) |
+   var         :  initOpaqueCastState (n^.varF.opaqueState, opaque, voidstar) |
+   array       :  initOpaqueCastState (n^.arrayF.opaqueState, opaque, voidstar) |
+   varparam    :  initOpaqueCastState (n^.varparamF.opaqueState, opaque, voidstar) |
+   param       :  initOpaqueCastState (n^.paramF.opaqueState, opaque, voidstar) |
+   pointer     :  initOpaqueCastState (n^.pointerF.opaqueState, opaque, voidstar) |
+   recordfield :  initOpaqueCastState (n^.recordfieldF.opaqueState, opaque, voidstar) |
+   componentref:  initOpaqueCastState (n^.componentrefF.opaqueState, opaque, voidstar) |
+   pointerref  :  initOpaqueCastState (n^.pointerrefF.opaqueState, opaque, voidstar) |
+   arrayref    :  initOpaqueCastState (n^.arrayrefF.opaqueState, opaque, voidstar) |
+   procedure   :  initOpaqueCastState (n^.procedureF.opaqueState, opaque, voidstar) |
+   proctype    :  initOpaqueCastState (n^.proctypeF.opaqueState, opaque, voidstar)
+
+   ELSE
+      HALT
+   END
+END initNodeOpaqueCastState ;
+
+
+(*
+   setOpaqueCastState - set the voidStar field in opaquestate.
+*)
+
+PROCEDURE setOpaqueCastState (VAR opaquestate: opaqueCastState; voidstar: BOOLEAN) ;
+BEGIN
+   opaquestate.voidStar := voidstar
+END setOpaqueCastState ;
+
+
+(*
+   setNodeOpaqueVoidStar - sets the voidStar field in node to voidstar.
+*)
+
+PROCEDURE setNodeOpaqueVoidStar (n: node; voidstar: BOOLEAN) ;
+BEGIN
+   assert (nodeUsesOpaque (n)) ;
+   CASE n^.kind OF
+
+   opaquecast  :  setOpaqueCastState (n^.opaquecastF.opaqueState, voidstar) |
+   funccall    :  setOpaqueCastState (n^.funccallF.opaqueState, voidstar) |
+   var         :  setOpaqueCastState (n^.varF.opaqueState, voidstar) |
+   array       :  setOpaqueCastState (n^.arrayF.opaqueState, voidstar) |
+   varparam    :  setOpaqueCastState (n^.varparamF.opaqueState, voidstar) |
+   param       :  setOpaqueCastState (n^.paramF.opaqueState, voidstar) |
+   pointer     :  setOpaqueCastState (n^.pointerF.opaqueState, voidstar) |
+   recordfield :  setOpaqueCastState (n^.recordfieldF.opaqueState, voidstar) |
+   componentref:  assert (NOT voidstar) ;
+                  setOpaqueCastState (n^.componentrefF.opaqueState, voidstar) |
+   pointerref  :  assert (NOT voidstar) ;
+                  setOpaqueCastState (n^.pointerrefF.opaqueState, voidstar) |
+   arrayref    :  setOpaqueCastState (n^.arrayrefF.opaqueState, voidstar) |
+   procedure   :  setOpaqueCastState (n^.procedureF.opaqueState, voidstar) |
+   proctype    :  setOpaqueCastState (n^.proctypeF.opaqueState, voidstar)
+
+   ELSE
+      HALT
+   END
+END setNodeOpaqueVoidStar ;
+
+
+(*
+   nodeUsesOpaque - return TRUE if node n uses an opaque type.
+*)
+
+PROCEDURE nodeUsesOpaque (n: node) : BOOLEAN ;
+BEGIN
+   CASE n^.kind OF
+
+   opaquecast  :  RETURN n^.opaquecastF.opaqueState.opaque |
+   funccall    :  RETURN n^.funccallF.opaqueState.opaque |
+   var         :  RETURN n^.varF.opaqueState.opaque |
+   array       :  RETURN n^.arrayF.opaqueState.opaque |
+   varparam    :  RETURN n^.varparamF.opaqueState.opaque |
+   param       :  RETURN n^.paramF.opaqueState.opaque |
+   pointer     :  RETURN n^.pointerF.opaqueState.opaque |
+   recordfield :  RETURN n^.recordfieldF.opaqueState.opaque |
+   componentref:  RETURN n^.componentrefF.opaqueState.opaque |
+   pointerref  :  RETURN n^.pointerrefF.opaqueState.opaque |
+   arrayref    :  RETURN n^.arrayrefF.opaqueState.opaque |
+   procedure   :  RETURN n^.procedureF.opaqueState.opaque |
+   proctype    :  RETURN n^.proctypeF.opaqueState.opaque |
+   deref       :  RETURN nodeUsesOpaque (n^.unaryF.arg)
+
+   ELSE
+      RETURN FALSE
+   END
+END nodeUsesOpaque ;
+
+
+(*
+   getNodeOpaqueVoidStar - return TRUE if the opaque type used by node n is a void *.
+*)
+
+PROCEDURE getNodeOpaqueVoidStar (n: node) : BOOLEAN ;
+BEGIN
+   assert (nodeUsesOpaque (n)) ;
+   CASE n^.kind OF
+
+   opaquecast  :  RETURN n^.opaquecastF.opaqueState.voidStar |
+   funccall    :  RETURN n^.funccallF.opaqueState.voidStar |
+   var         :  RETURN n^.varF.opaqueState.voidStar |
+   array       :  RETURN n^.arrayF.opaqueState.voidStar |
+   varparam    :  RETURN n^.varparamF.opaqueState.voidStar |
+   param       :  RETURN n^.paramF.opaqueState.voidStar |
+   pointer     :  RETURN n^.pointerF.opaqueState.voidStar |
+   recordfield :  RETURN n^.recordfieldF.opaqueState.voidStar |
+   componentref:  RETURN n^.componentrefF.opaqueState.voidStar |
+   pointerref  :  RETURN n^.pointerrefF.opaqueState.voidStar |
+   arrayref    :  RETURN n^.arrayrefF.opaqueState.voidStar |
+   procedure   :  RETURN n^.procedureF.opaqueState.voidStar |
+   proctype    :  RETURN n^.proctypeF.opaqueState.voidStar |
+   deref       :  RETURN FALSE
+
+   ELSE
+      HALT
+   END
+END getNodeOpaqueVoidStar ;
+
+
+(*
+   getOpaqueFlushNecessary - return TRUE if the value next differs from the opaque state.
+*)
+
+PROCEDURE getOpaqueFlushNecessary (state: opaqueCastState; next: BOOLEAN) : BOOLEAN ;
+BEGIN
+   RETURN state.opaque AND (state.voidStar # next)
+END getOpaqueFlushNecessary ;
+
+
+(*
+   getNodeOpaqueFlushNecessary - return TRUE if the value of next requires a cast.
+*)
+
+PROCEDURE getNodeOpaqueFlushNecessary (n: node; next: BOOLEAN) : BOOLEAN ;
+BEGIN
+   CASE n^.kind OF
+
+   opaquecast  :  RETURN getOpaqueFlushNecessary (n^.opaquecastF.opaqueState, next) |
+   funccall    :  RETURN getOpaqueFlushNecessary (n^.funccallF.opaqueState, next) |
+   var         :  RETURN getOpaqueFlushNecessary (n^.varF.opaqueState, next) |
+   array       :  RETURN getOpaqueFlushNecessary (n^.arrayF.opaqueState, next) |
+   varparam    :  RETURN getOpaqueFlushNecessary (n^.varparamF.opaqueState, next) |
+   param       :  RETURN getOpaqueFlushNecessary (n^.paramF.opaqueState, next) |
+   pointer     :  RETURN getOpaqueFlushNecessary (n^.pointerF.opaqueState, next) |
+   recordfield :  RETURN getOpaqueFlushNecessary (n^.recordfieldF.opaqueState, next) |
+   componentref:  RETURN getOpaqueFlushNecessary (n^.componentrefF.opaqueState, next) |
+   pointerref  :  RETURN getOpaqueFlushNecessary (n^.pointerrefF.opaqueState, next) |
+   arrayref    :  RETURN getOpaqueFlushNecessary (n^.arrayrefF.opaqueState, next) |
+   procedure   :  RETURN getOpaqueFlushNecessary (n^.procedureF.opaqueState, next) |
+   proctype    :  RETURN getOpaqueFlushNecessary (n^.proctypeF.opaqueState, next)
+
+   ELSE
+      RETURN FALSE
+   END
+END getNodeOpaqueFlushNecessary ;
+
+
+(*
+   makeOpaqueCast - wrap node n with an opaquecast node and assign
+                    voidstar into the new opaque state.
+*)
+
+PROCEDURE makeOpaqueCast (n: node; voidstar: BOOLEAN) : node ;
+VAR
+   o: node ;
+BEGIN
+   o := newNode (opaquecast) ;
+   WITH o^.opaquecastF DO
+      exp := n ;
+      initOpaqueCastState (opaqueState, TRUE, voidstar)
+   END ;
+   RETURN o
+END makeOpaqueCast ;
+
+
+(*
+   flushOpaque - perform a cast to voidstar (if necessary) and ignore the new
+                 node which could be created.
+*)
+
+PROCEDURE flushOpaque (p: pretty; n: node; toVoidStar: BOOLEAN) ;
+VAR
+   o: node ;
+BEGIN
+   o := castOpaque (p, n, toVoidStar)
+END flushOpaque ;
+
+
+(*
+   castOpaque - flushes the opaque type casts if necessary and changes the
+                voidstar boolean value.   If necessary it creates a opaquecast
+                and returns the new node otherwise return n.
+*)
+
+PROCEDURE castOpaque (p: pretty; n: node; toVoidStar: BOOLEAN) : node ;
+VAR
+   type: node ;
+BEGIN
+   IF getNodeOpaqueFlushNecessary (n, toVoidStar)
+   THEN
+      type := getType (n) ;
+      IF toVoidStar
+      THEN
+         (* next is true cast to void * opaque type.  *)
+         outText (p, 'static_cast<') ;
+         doTypeNameC (p, type) ;
+         noSpace (p) ;
+         outText (p, '> (') ;
+         doExprC (p, n) ;
+         outText (p, ')') ;
+         RETURN makeOpaqueCast (n, TRUE)
+      ELSE
+         (* next is false cast to __opaque opaque type.  *)
+         outText (p, 'static_cast<') ;
+         doTypeNameC (p, type) ;
+         outText (p, '__opaque') ;
+         noSpace (p) ;
+         outText (p, '> (') ;
+         doExprC (p, n) ;
+         outText (p, ')') ;
+         RETURN makeOpaqueCast (n, FALSE)
+      END
+   ELSE
+      IF debugOpaque
+      THEN
+         doP := p ;
+         dumpOpaqueState (n) ;
+         IF nodeUsesOpaque (n)
+         THEN
+            outText (p, ' /* no difference seen */ ')
+         ELSE
+            outText (p, ' /* no opaque used */ ')
+         END
+      END ;
+      doExprC (p, n)
+   END ;
+   RETURN n
+END castOpaque ;
+
+
+(*
+   isTypeOpaqueDefImp - returns TRUE if type is an opaque type by checking
+                        the def/imp pair of modules or fall back to the
+                        definition module.
+*)
+
+PROCEDURE isTypeOpaqueDefImp (type: node) : BOOLEAN ;
+VAR
+   scope,
+   def,
+   opaque: node ;
+BEGIN
+   IF type = NIL
+   THEN
+      RETURN FALSE
+   ELSIF isType (type)
+   THEN
+      scope := getScope (type) ;
+      IF isImp (scope)
+      THEN
+         def := lookupDef (getSymName (scope)) ;
+         IF def # NIL
+         THEN
+            (* Lookup the type name in the matching definition module.  *)
+            opaque := lookupExported (def, getSymName (type)) ;
+            RETURN (opaque # NIL) AND isType (opaque) AND isTypeOpaque (opaque)
+         END
+      ELSE
+         (* Otherwise just check the definition module.  *)
+         RETURN isTypeOpaque (type)
+      END
+   END ;
+   RETURN FALSE
+END isTypeOpaqueDefImp ;
+
+
+(*
+   isParamVoidStar - return TRUE if the procedure or proctype opaque type
+                     parameter should be implemented as a (void * ).
+*)
+
+PROCEDURE isParamVoidStar (n: node) : BOOLEAN ;
+VAR
+   proc,
+   type: node ;
+BEGIN
+   proc := getScope (n) ;
+   assert (isProcedure (proc) OR isProcType (proc)) ;
+   type := getType (n) ;
+   RETURN isReturnVoidStar (proc, type)
+END isParamVoidStar ;
+
+
+(*
+   isRefVoidStar - returns TRUE if the ref node uses an opaque type which
+                   is represented as a (void * ).
+*)
+
+PROCEDURE isRefVoidStar (n: node) : BOOLEAN ;
+VAR
+   type: node ;
+BEGIN
+   type := getType (n) ;
+   IF (NOT isType (type)) OR (NOT isTypeOpaque (type))
+   THEN
+      (* We should finish the procedure as the ref does not use an opaque.  *)
+      RETURN TRUE
+   ELSE
+      (* We check whether the opaque type was declared in the implementation
+         module.  If it is declared in the implementation module then we
+         return FALSE.  *)
+      RETURN NOT isDeclInImp (type)
+   END
+END isRefVoidStar ;
+
+
+(*
+   isReturnVoidStar - return TRUE if the procedure or proctype opaque type
+                      return type should be implemented as a (void * ).
+*)
+
+PROCEDURE isReturnVoidStar (proc, type: node) : BOOLEAN ;
+VAR
+   def : node ;
+BEGIN
+   assert (isProcedure (proc) OR isProcType (proc)) ;
+   IF isExported (proc)
+   THEN
+      RETURN TRUE
+   ELSE
+      (* Not exported therefore local, we check whether the opaque type
+         was declared in the implementation module.  *)
+      IF isImp (currentModule)
+      THEN
+         IF isType (type)
+         THEN
+            RETURN NOT isDeclInImp (type)
+         ELSE
+            RETURN FALSE
+         END
+      ELSE
+         (* Always use void * in .def modules.  *)
+         RETURN TRUE
+      END
+   END
+END isReturnVoidStar ;
+
+
+(*
+   isVarVoidStar - return TRUE if the variable using an opaque type should
+                   be implemented as a (void * ).
+*)
+
+PROCEDURE isVarVoidStar (n: node) : BOOLEAN ;
+VAR
+   type: node ;
+BEGIN
+   assert (isVar (n)) ;
+   type := getType (n) ;
+   IF (NOT isType (type)) OR (NOT isTypeOpaque (type))
+   THEN
+      (* We should finish the procedure as the variable does not use an opaque.  *)
+      RETURN TRUE
+   ELSIF isExported (n)
+   THEN
+      (* Exported variables using an opaque type will always be implemented
+         with a (void * ).  *)
+      RETURN TRUE
+   ELSE
+      (* Not exported therefore static to the module (local or global non exported
+         variable), we check whether the opaque type was declared in the
+         implementation module.  If it is declared in the implementation module
+         then we return FALSE.  *)
+      RETURN NOT isDeclInImp (type)
+   END
+END isVarVoidStar ;
+
+
+(*
+   initNodeOpaqueState - initialize the node opaque state.
+*)
+
+PROCEDURE initNodeOpaqueState (n: node) ;
+VAR
+   type: node ;
+BEGIN
+   CASE n^.kind OF
+
+   opaquecast  :  |  (* This must be done when the cast direction is known.  *)
+   funccall    :  assignNodeOpaqueCastState (n, getFunction (n)) |
+   var         :  type := getType (n) ;
+                  IF n^.varF.isParameter OR n^.varF.isVarParameter
+                  THEN
+                     (* If the variable is really a parameter then it uses
+                        the state of the parameter.  *)
+                     initNodeOpaqueCastState (n, isTypeOpaqueDefImp (type),
+                                              isParamVoidStar (n))
+                  ELSE
+                     initNodeOpaqueCastState (n, isTypeOpaqueDefImp (type),
+                                              isVarVoidStar (n))
+                  END  |
+   array       :  type := getType (n) ;
+                  initNodeOpaqueCastState (n, isTypeOpaqueDefImp (type),
+                                           isExported (n)) |
+   varparam,
+   param       :  assert (isProcedure (getScope (n)) OR isProcType (getScope (n))) ;
+                  type := getType (n) ;
+                  initNodeOpaqueCastState (n, isTypeOpaqueDefImp (type),
+                                           isParamVoidStar (n)) |
+   componentref,
+   pointerref,
+   pointer,
+   recordfield,
+   arrayref    :  type := getType (n) ;
+                  (* In the future this should be revisited.  *)
+                  initNodeOpaqueCastState (n, isTypeOpaqueDefImp (type),
+                                           isRefVoidStar (n)) |
+                          (* For the moment treat as never exported.  *)
+   proctype,
+   procedure   :  (* We only consider the return type for a procedure or proctype.
+                     The parameters and local vars are handled separately (see
+                     above).  *)
+                  type := getType (n) ;
+                  IF type = NIL
+                  THEN
+                     (* No return type, therefore no opaque type used.  *)
+                     initNodeOpaqueCastState (n, FALSE, FALSE)
+                  ELSE
+                     (* Init state from the return type.  Is type an opaque type?
+                        Is the opaque type declared in this module?  *)
+                     initNodeOpaqueCastState (n, isTypeOpaqueDefImp (type),
+                                              isReturnVoidStar (n, type))
+                  END |
+
+   ELSE
+   END ;
+   IF debugOpaque
+   THEN
+      dumpOpaqueState (n)
+   END
+END initNodeOpaqueState ;
+
+
+(*
+   assignNodeOpaqueCastState - copy the opaqueCastState from src into dest.
+*)
+
+PROCEDURE assignNodeOpaqueCastState (dest, src: node) ;
+BEGIN
+   IF nodeUsesOpaque (src)
+   THEN
+      initNodeOpaqueCastState (dest, TRUE, getNodeOpaqueVoidStar (src))
+   ELSE
+      initNodeOpaqueCastState (dest, FALSE, FALSE)
+   END
+END assignNodeOpaqueCastState ;
+
+
+(*
+   assignNodeOpaqueCastFalse - assign the voidstar field of dest to false.
+                               It assigns the opaque field of dest to the value
+                               of the src opaque field.
+*)
+
+PROCEDURE assignNodeOpaqueCastFalse (dest, src: node) ;
+BEGIN
+   IF nodeUsesOpaque (src)
+   THEN
+      initNodeOpaqueCastState (dest, TRUE, FALSE)
+   ELSE
+      initNodeOpaqueCastState (dest, FALSE, FALSE)
+   END
+END assignNodeOpaqueCastFalse ;
+
+
+(*
+   dumpOpaqueState -
+*)
+
+PROCEDURE dumpOpaqueState (n: node) ;
+VAR
+   o: node ;
+BEGIN
+   CASE n^.kind OF
+
+   opaquecast,
+   funccall,
+   var,
+   array,
+   varparam,
+   param,
+   pointer,
+   recordfield,
+   componentref,
+   arrayref,
+   procedure,
+   proctype    :  o := n
+
    ELSE
-      doTypeNameC (p, paramtype)
+      o := NIL
+   END ;
+   IF o # NIL
+   THEN
+      outText (doP, "/* ") ;
+      doNameC (doP, o) ;
+      outText (doP, "  ") ;
+      CASE o^.kind OF
+
+      opaquecast  :  outText (doP, "opaquecast") |
+      funccall    :  outText (doP, "funccall") |
+      var         :  outText (doP, "var") |
+      array       :  outText (doP, "array") |
+      varparam    :  outText (doP, "varparam") |
+      param       :  outText (doP, "param") |
+      pointer     :  outText (doP, "pointer") |
+      recordfield :  outText (doP, "recordfield") |
+      componentref:  outText (doP, "componentref") |
+      pointerref  :  outText (doP, "pointerref") |
+      arrayref    :  outText (doP, "arrayref") |
+      procedure   :  outText (doP, "procedure") |
+      proctype    :  outText (doP, "proctype")
+
+      ELSE
+      END ;
+      IF nodeUsesOpaque (o)
+      THEN
+         IF getNodeOpaqueVoidStar (o)
+         THEN
+            outText (doP, " uses (void *) opaque")
+         ELSE
+            outText (doP, " uses opaque__full")
+         END ;
+      END ;
+      outText (doP, " */ \n")
    END
-END doParamTypeEmit ;
+END dumpOpaqueState ;
 
 
 (*
@@ -7369,10 +8059,7 @@ BEGIN
             ELSE
                doFQDNameC (p, v, TRUE)
             END ;
-            IF isArray (ptype) AND isUnbounded (ptype)
-            THEN
-               outText (p, '_')
-            END ;
+            doParamTypeNameModifier (p, ptype, FALSE) ;
             doUsed (p, n^.paramF.isUsed) ;
             doHighC (p, ptype, i, n^.paramF.isUsed) ;
             IF c<t
@@ -7440,6 +8127,7 @@ BEGIN
             ELSE
                doFQDNameC (p, v, TRUE)
             END ;
+            doParamTypeNameModifier (p, ptype, TRUE) ;
             doUsed (p, n^.varparamF.isUsed) ;
             doHighC (p, ptype, i, n^.varparamF.isUsed) ;
             IF c<t
@@ -7508,11 +8196,63 @@ END doParameterC ;
 PROCEDURE doProcTypeC (p: pretty; t, n: node) ;
 BEGIN
    assert (isType (t)) ;
-   outputPartial (t) ;
-   doCompletePartialProcType (p, t, n)
+   IF isDeclType (t) AND isDeclType (n)
+   THEN
+      outputPartial (t) ;
+      doCompletePartialProcType (p, t, n)
+   END
 END doProcTypeC ;
 
 
+(*
+   isDeclInImp - returns TRUE if node type is declared as an opaque and
+                 is declared fully in the current implementation module.
+                 This should only be called if isType (type).  Its purpose
+                 is specific to a type checking whether it is an opaque type
+                 declared in the .def/.mod pair of the current imp module.
+*)
+
+PROCEDURE isDeclInImp (type: node) : BOOLEAN ;
+VAR
+   scope,
+   def  : node ;
+   name : Name ;
+BEGIN
+   assert (isType (type)) ;
+   scope := getScope (type) ;
+   IF isTypeOpaqueDefImp (type) AND isImp (currentModule)
+   THEN
+      name := getSymName (type) ;
+      IF name # NulName
+      THEN
+         (* Lookup the matching .def module.  *)
+         def := lookupDef (getSymName (currentModule)) ;
+         IF (def # NIL) AND ((def = scope) OR (currentModule = scope))
+         THEN
+            (* Return TRUE if the symbol has already been declared in the .def.  *)
+            RETURN lookupExported (def, name) # NIL
+         END
+      END
+   END ;
+   RETURN FALSE
+END isDeclInImp ;
+
+
+(*
+   doTypeNameModifier - adds the __opaque modifier to the type n provided
+                        it is an opaque type which is being declared in the
+                        implementation module.
+*)
+
+PROCEDURE doTypeNameModifier (p: pretty; n: node) ;
+BEGIN
+   IF isTypeOpaqueDefImp (n) AND isImp (currentModule)
+   THEN
+      outText (p, '__opaque')
+   END
+END doTypeNameModifier ;
+
+
 (*
    doTypesC -
 *)
@@ -7536,14 +8276,18 @@ BEGIN
             setNeedSpace (doP)
          END ;
          doTypeNameC (doP, n) ;
+         doTypeNameModifier (doP, n) ;
          outText (doP, ";\n\n")
       ELSIF isEnumeration (m)
       THEN
-         outText (doP, "typedef") ; setNeedSpace (doP) ;
-         doTypeC (doP, m, m) ;
-         setNeedSpace (doP) ;
-	 doTypeNameC (doP, n) ;
-         outText (doP, ";\n\n")
+         IF isDeclType (n)
+         THEN
+            outText (doP, "typedef") ; setNeedSpace (doP) ;
+            doTypeC (doP, m, m) ;
+            setNeedSpace (doP) ;
+            doTypeNameC (doP, n) ;
+            outText (doP, ";\n\n")
+         END
       ELSE
          outText (doP, "typedef") ; setNeedSpace (doP) ;
          doTypeC (doP, m, m) ;
@@ -7552,6 +8296,7 @@ BEGIN
             setNeedSpace (doP)
          END ;
          doTypeNameC (doP, n) ;
+         doTypeNameModifier (doP, n) ;
          outText (doP, ";\n\n")
       END
    END
@@ -7606,7 +8351,6 @@ BEGIN
       THEN
          IF NOT f^.recordfieldF.tag
          THEN
-            setNeedSpace (p) ;
             doRecordFieldC (p, f) ;
             outText (p, ";\n")
          END
@@ -7864,6 +8608,19 @@ END doSubrC ;
 *)
 
 PROCEDURE doCompletePartialProcType (p: pretty; t, n: node) ;
+BEGIN
+   IF isDeclType (t) AND isDeclType (n)
+   THEN
+      outputCompletePartialProcType (p, t, n)
+   END
+END doCompletePartialProcType ;
+
+
+(*
+   outputCompletePartialProcType -
+*)
+
+PROCEDURE outputCompletePartialProcType (p: pretty; t, n: node) ;
 VAR
    i, h: CARDINAL ;
    v, u: node ;
@@ -7871,7 +8628,9 @@ BEGIN
    assert (isProcType (n)) ;
    u := NIL ;
    outText (p, "typedef") ; setNeedSpace (p) ;
-   doTypeC (p, n^.proctypeF.returnType, u) ; setNeedSpace (p) ;
+   doTypeC (p, n^.proctypeF.returnType, u) ;
+   doOpaqueModifier (p, n) ;
+   setNeedSpace (p) ;
    outText (p, "(*") ;
    doFQNameC (p, t) ;
    outText (p, "_t) (") ;
@@ -7906,7 +8665,7 @@ BEGIN
    outText (p, "_p {") ; setNeedSpace (p) ;
    doFQNameC (p, t) ;
    outText (p, "_t proc; };\n\n")
-END doCompletePartialProcType ;
+END outputCompletePartialProcType ;
 
 
 (*
@@ -8092,6 +8851,11 @@ BEGIN
    m := NIL ;
    setNeedSpace (p) ;
    doTypeC (p, f^.recordfieldF.type, m) ;
+   IF isType (f^.recordfieldF.type) AND isDeclInImp (f^.recordfieldF.type)
+   THEN
+      outText (p, '__opaque')
+   END ;
+   setNeedSpace (p) ;
    doDNameC (p, f, FALSE)
 END doRecordFieldC ;
 
@@ -8298,14 +9062,7 @@ BEGIN
       doEnumerationC (p, n)
    ELSIF isType (n)
    THEN
-      doFQNameC (p, n) ;
-      setNeedSpace (p)
-      (* doTypeAliasC (p, n, n) *)  (* type, n, has a name, so we choose this over, m.  *)
-(*
-   ELSIF isProcType (n) OR isArray (n) OR isRecord (n)
-   THEN
-      HALT  (* n should have been simplified.  *)
-*)
+      doFQNameC (p, n)
    ELSIF isProcType (n)
    THEN
       doProcTypeC (p, n, m)
@@ -8408,8 +9165,7 @@ BEGIN
    THEN
       doSubrangeC (p, n)
    ELSE
-      print (p, "is type unknown required\n") ;
-      stop
+      print (p, "is type unknown required\n")
    END
 END doTypeNameC ;
 
@@ -8430,32 +9186,70 @@ END isExternal ;
 
 
 (*
-   doVarC -
+   doOpaqueModifier - adds postfix __opaque providing n uses an opaque type which is
+                      not represented by ( void * ).  n is a non type node which might
+                      be using an opaque type.  For example a var or param node.
 *)
 
-PROCEDURE doVarC (n: node) ;
+PROCEDURE doOpaqueModifier (p: pretty; n: node) ;
+BEGIN
+   assert (NOT isType (n)) ;
+   IF isImp (getCurrentModule ()) AND nodeUsesOpaque (n) AND (NOT getNodeOpaqueVoidStar (n))
+   THEN
+      outText (doP, '__opaque')
+   END
+END doOpaqueModifier ;
+
+
+(*
+   doDeclareVarC -
+*)
+
+PROCEDURE doDeclareVarC (n: node) ;
 VAR
-   s: node ;
+   type,
+   s   : node ;
+BEGIN
+   s := NIL ;
+   type := getType (n) ;
+   doTypeC (doP, type, s) ;
+   doOpaqueModifier (doP, n) ;
+   setNeedSpace (doP) ;
+   doFQDNameC (doP, n, FALSE) ;
+   print (doP, ";\n")
+END doDeclareVarC ;
+
+
+(*
+   doVarC - output a variable declaration.  Note that we do not generate
+            a declaration if we are translating the implementation module
+            and a variable is exported as the variable will be in the .h
+            file to avoid all -Wodr issues.
+*)
+
+PROCEDURE doVarC (n: node) ;
 BEGIN
    IF isDef (getMainModule ())
    THEN
-      print (doP, "EXTERN") ; setNeedSpace (doP)
+      print (doP, "EXTERN") ; setNeedSpace (doP) ;
+      doDeclareVarC (n)
    ELSIF (NOT isExported (n)) AND (NOT isLocal (n))
    THEN
-      print (doP, "static") ; setNeedSpace (doP)
+      print (doP, "static") ; setNeedSpace (doP) ;
+      doDeclareVarC (n)
    ELSIF getExtendedOpaque ()
    THEN
+      (* --fixme-- need to revisit extended opaque.  *)
       IF isExternal (n)
       THEN
          (* different module declared this variable, therefore it is extern.  *)
          print (doP, "extern") ; setNeedSpace (doP)
-      END
-   END ;
-   s := NIL ;
-   doTypeC (doP, getType (n), s) ;
-   setNeedSpace (doP) ;
-   doFQDNameC (doP, n, FALSE) ;
-   print (doP, ";\n")
+      END ;
+      doDeclareVarC (n)
+   ELSIF isLocal (n)
+   THEN
+      doDeclareVarC (n)
+   END
 END doVarC ;
 
 
@@ -8507,10 +9301,17 @@ END doProcedureComment ;
 
 PROCEDURE doProcedureHeadingC (n: node; prototype: BOOLEAN) ;
 VAR
+   s   : String ;
    i, h: CARDINAL ;
    p, q: node ;
 BEGIN
    assert (isProcedure (n)) ;
+   s := getFQstring (n) ;
+   IF EqualArray (s, 'M2Quads_BuildAssignment')
+   THEN
+      localstop
+   END ;
+   s := KillString (s) ;
    noSpace (doP) ;
    IF isDef (getMainModule ())
    THEN
@@ -8525,7 +9326,15 @@ BEGIN
       outText (doP, "static") ; setNeedSpace (doP)
    END ;
    q := NIL ;
-   doTypeC (doP, n^.procedureF.returnType, q) ; setNeedSpace (doP) ;
+   doTypeC (doP, n^.procedureF.returnType, q) ;
+   (*
+   IF NOT isExported (n)
+   THEN
+      doTypeNameModifier (doP, n^.procedureF.returnType)
+   END ;
+   *)
+   doOpaqueModifier (doP, n) ;
+   setNeedSpace (doP) ;
    doFQDNameC (doP, n, FALSE) ;
    setNeedSpace (doP) ;
    outText (doP, "(") ;
@@ -9301,18 +10110,26 @@ END doAfterCommentC ;
 *)
 
 PROCEDURE doReturnC (p: pretty; s: node) ;
+VAR
+   type: node ;
 BEGIN
    assert (isReturn (s)) ;
    doCommentC (p, s^.returnF.returnComment.body) ;
    outText (p, "return") ;
-   IF s^.returnF.scope#NIL
+   IF (s^.returnF.scope#NIL) AND (s^.returnF.exp#NIL)
    THEN
       setNeedSpace (p) ;
       IF (NOT isProcedure (s^.returnF.scope)) OR (getType (s^.returnF.scope)=NIL)
       THEN
          metaError1 ('{%1DMad} has no return type', s^.returnF.scope) ;
       ELSE
-         doExprCastC (p, s^.returnF.exp, getType (s^.returnF.scope))
+         IF isProcedure (s^.returnF.scope) AND nodeUsesOpaque (s^.returnF.scope)
+         THEN
+            forceCastOpaque (p, s^.returnF.scope, s^.returnF.exp,
+                             getNodeOpaqueVoidStar (s^.returnF.scope))
+         ELSE
+            doExprCastC (p, s^.returnF.exp, getType (s^.returnF.scope))
+         END
       END
    END ;
    outText (p, ";") ;
@@ -9372,7 +10189,7 @@ BEGIN
          (* potentially a cast is required.  *)
          IF isPointer (type) OR (type = addressN)
          THEN
-            outText (p, 'reinterpret_cast<') ;
+            outText (p, 'static_cast<') ;
             doTypeNameC (p, type) ;
             noSpace (p) ;
             outText (p, '> (') ;
@@ -9412,6 +10229,80 @@ BEGIN
 END requiresUnpackProc ;
 
 
+(*
+   forceCastOpaque -
+*)
+
+PROCEDURE forceCastOpaque (p: pretty; des, expr: node; toVoidStar: BOOLEAN) ;
+BEGIN
+   IF nodeUsesOpaque (expr)
+   THEN
+      flushOpaque (p, expr, getNodeOpaqueVoidStar (des))
+   ELSE
+      forceReintCastOpaque (p, des, expr, toVoidStar)
+   END
+END forceCastOpaque ;
+
+
+(*
+   forceReintCastOpaque -
+*)
+
+PROCEDURE forceReintCastOpaque (p: pretty; des, expr: node; toVoidStar: BOOLEAN) ;
+VAR
+   type: node ;
+BEGIN
+   type := getType (des) ;
+   IF toVoidStar
+   THEN
+      (* next is true cast to void * opaque type.  *)
+      outText (p, 'static_cast<') ;
+      doTypeNameC (p, type) ;
+      noSpace (p) ;
+      outText (p, '> (') ;
+      doExprC (p, expr) ;
+      outText (p, ')')
+   ELSE
+      (* next is false cast to __opaque opaque type.  *)
+      outText (p, 'static_cast<') ;
+      doTypeNameC (p, type) ;
+      outText (p, '__opaque') ;
+      noSpace (p) ;
+      outText (p, '> (') ;
+      doExprC (p, expr) ;
+      outText (p, ')') ;
+   END
+END forceReintCastOpaque ;
+
+
+(*
+   doUnConstCastUnbounded - if node n type is an unbounded array then
+                            use const_cast to remove the const parameter
+                            to allow the unbounded array to be modified.
+*)
+
+PROCEDURE doUnConstCastUnbounded (p: pretty; n: node) ;
+VAR
+   type, v: node ;
+BEGIN
+   IF isArrayRef (n)
+   THEN
+      IF isVar (n^.arrayrefF.array)
+      THEN
+         v := n^.arrayrefF.array ;
+         IF (v^.varF.isParameter OR v^.varF.isVarParameter) AND
+	    isUnbounded (getType (v))
+         THEN
+            type := getType (v) ;
+            outText (p, " /* const_cast<") ;
+            doTypeNameC (p, type) ;
+            outText (p, "> is needed */ ") ;
+         END
+      END
+   END
+END doUnConstCastUnbounded ;
+
+
 (*
    doAssignmentC -
 *)
